unit UGame;
//*****************************************************************************
// Unit UGame           - Diese Unit enthlt alle Routinen, die wichtig fr
// -------------          Spiel-Logik bzw. Spielverlauf sind.
//
// ffentliche-Funktionen:
// -----------------------
// SekToPlayTime        - Berechnet Std, Min, Sek Anteil aus Sekunden
// PlayTimeToSek        - Berechnet Sekunden aus den Anteilen Std, Min und Sek
// SekToStr             - Wandelt Sekunden in String aus Std, Min und Sek um
//
// Verwendet eigene Units:
// -----------------------
// UType                - Enthlt wichtige Typen
// UFile                - enthlt Routinen zum Lesen der Spiele-Grafiken aus
//                        verschiedenen Dateien
//
// Vordiploms-Programm  - (c) Januar 2003,  by Andreas Schibilla
// -------------------
//
//*****************************************************************************
interface

uses IniFiles, SysUtils, UType;

function  SekToPlayTime(Sek : Cardinal) : TPlayTime;
function  PlayTimeToSek(PlayTime : TPlayTime) : Cardinal;
function  SekToStr(Sek : Cardinal) : String;

implementation

uses UFile;

//*****************************************************************************
// Berechnet Std, Min, Sek Anteil aus einer Sekunden-bergabe
//
//  ->   Sek         Sekunden, die aufgeteilt werden sollen
// <                 Gibt die aufgeteilten Anteile zurck
//
// as, 25.09.2002 - Erste Version
//*****************************************************************************
function SekToPlayTime(Sek : Cardinal) : TPlayTime;
var
 PlayTime : TPlayTime;
begin

 PlayTime.Hours   := Sek div 3600;        // Std = 60 Sek * 60 Min
 Sek              := Sek mod 3600;        // ziehe ganze Std ab
 PlayTime.Minutes := Sek div 60;          // brig bleiben die Minuten
 PlayTime.Seconds := Sek mod 60;          // der Rest entspr. den Sekunden
 SekToPlayTime    := PlayTime;            // gebe die Berechnungen zurck
end;


//*****************************************************************************
// Berechnet Sekunden aus den Anteilen Std, Min und Sek
//
//  ->   PlayTime    Record, das die Std, Min und Sek enthlt
// <                 gibt Zeit in Sekunden zurck
//
// as, 26.09.2002 - Erste Version
//*****************************************************************************
function PlayTimeToSek(PlayTime : TPlayTime) : Cardinal;
begin
 PlayTimeToSek    := (PlayTime.Hours * 3600) + (PlayTime.Minutes * 60) + (PlayTime.Seconds);
end;


//*****************************************************************************
// Wandelt Sekunden in einen String bestehend aus Std, Min und Sek
//
//  ->   Sek         Anzahl der Sekunden
// <                 Gibt den aus den Sekunden ermittelten String zurck
//
// as, 25.09.2002 - Erste Version
//*****************************************************************************
function SekToStr(Sek : Cardinal) : String;
var
 PlayTime : TPlayTime;
 Str      : String;
begin
 PlayTime := SekToPlayTime(Sek);                               // berechne Std, Min und Sek aus den Gesamt-Sekunden
 Str := '';                                                                            // Strin init.
 if PlayTime.Hours   > 0 then  Str := Str + IntToStr(playTime.Hours)   + ' Std ';      // ergnze Std, wenn mind 1 Std
 if PlayTime.Minutes > 0 then  Str := Str + IntToStr(playTime.Minutes) + ' Min ';      // Minuten, wenn mind 1 Min
 if PlayTime.Seconds > 0 then  Str := Str + IntToStr(playTime.Seconds) + ' Sek ';      // Sekunden, wenn mind 1 Sek
 SekToStr := Str;                                              // Gebe den fertigen String zurck
end;

end.
