unit UInput;
//*****************************************************************************
// Unit UInput          - Diese Formular-Unit stellt ein Formular bereit, wo
// -------------          der Spieler seinen Namen eingeben kann, damit sein
//                        Name in die Highscore gelangt
//
// ffentliche-Methoden:
// ---------------------
// GetInputString       - Mit Hilfe dieser Funktion kann der eingegebene Name
//                        erfragt werden
//
// Verwendet eigene Units:
// -----------------------
//                      - verwendet keine eigenen Units, nur Delphi-Standard
//
// Vordiploms-Programm  - (c) Januar 2003,  by Andreas Schibilla
// -------------------
//
//*****************************************************************************
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TInputForm = class(TForm)
    LaTitle: TLabel;
    LaInfo1: TLabel;
    LaInfo2: TLabel;
    EdInput: TEdit;
    BtnOk: TButton;
    procedure FormHide(Sender: TObject);
  private
    { Private-Deklarationen }
    StrInput: String;
  public
    { Public-Deklarationen }
    function GetInputString : String;
  end;

var
  InputForm: TInputForm;

implementation

//*****************************************************************************
// Initialisiert die Liste der Text-Objekte
//
// as, 03.01.2003 - Erste Version
//*****************************************************************************
function TInputForm.GetInputString : String;
begin
 if StrLen(PChar(StrInput)) < 1 then      // Wenn kein Text eingegeben wurde
    StrInput := 'Herr/Frau ???';          // dann benutze Standard-String fr Highscore
 GetInputString := StrInput;
end;

{$R *.dfm}

//*****************************************************************************
// Speichert den eingegebenen Text des Editfelds
//
// Wird aufgerufen, wenn das Dialogfeld durch Klick auf OK, Drcken von Enter
// oder ESC geschlossen wird
//
// as, 03.01.2003 - Erste Version
//*****************************************************************************
procedure TInputForm.FormHide(Sender: TObject);
begin
 StrInput := EdInput.Text;
end;

end.
