unit UType;
//*****************************************************************************
// Unit UType           - Diese Unit enthlt alle fr das Spiel relevanten
// -------------          Datentypen und Konstanten
//
// Stellt keine ffentliche Funktionen bereit!
// -------------------------------------------
//
// Verwendet keine eigenen Units!
// ------------------------------
//
// Vordiploms-Programm  - (c) Januar 2003,  by Andreas Schibilla
// -------------------
//
//*****************************************************************************
interface

uses Windows, Graphics, Controls;

const

C_STARCOLORS            : array[1..5] of TColor =
                        ( $FFFFFF, $FFFF00, $FFC0C0, $C0FFFF, $FF4040 );

C_MAX_STAR_WIDTH        = 2;                    // Max. Breite eines Sternes
C_MAX_STAR_HEIGHT       = 3;                    // Max. Hhe eines Sternes

C_KILLPOINTSCOLOR       = clLime;               // welche Farbe hat der Text "Gegner-getroffen-Punktzahl"
C_FONTNAME              = 'Arial';              // welche Schriftarte wird benutzt

C_TRANSPARENT           = False;                // schaltet transparente Spiele-Grafiken ein (VORSICHT: lansgam und nicht vollst. impl.!)


C_DEF_PLAYERNAME        = 'Irgendwer';          // Standard Spieler-Name fr Highscore
C_DEF_PLAYFIELD         = 500;                  // Standard Spielfeldgre (Width, Height von TImage beachten)
C_DEF_LEVELTIME         = 300;                  // Standard-Level-Rundenzeit
C_DEF_LIVES             = 3;                    // Standard Anzahl Leben des Spielers
C_DEF_ENEMY_SPEED_POTI  = 0.05;                 // Faktor zum Feintunen der Gegner-Geschwindigkeit
C_DEF_LEFT              = VK_LEFT;              // Standard Steuer-Taste fr Bewegung nach links
C_DEF_RIGHT             = VK_RIGHT;             // Standard Steuer-Taste fr Bewegung nach rechts
C_DEF_FIRE              = VK_SPACE;             // Standard Steuer-Taste fr Schuss
C_DEF_PAUSE             = VK_PAUSE;             // Standard Steuer-Taste zur Spiel-Pause

C_PLAYER_MOVE_SPEED     = 3;                    // Wie schnell bewegt sich der Spieler?
C_PLAYER_SHOOT_SPEED    = 6;                    // und wie schnell seine Schsse?

C_MAX_PLAYER_SHOOT      = 5;                    // Wieviele Schsse darf der Spieler jeweils auf dem Spielfeld haben?

C_CONFIG_FILE           = 'config.ini';         // Standard-Config-Datei
C_GAME_BMP_FILE         = 'default.dat';        // Standard Datei mit den Spiel-Grafiken

C_MAX_PLAYERNAME_LEN    = 20;                   // Max. Lnge des Spieler-Namens in der Highscore
C_MAX_HIGHSCORE_ENTRIES = 10;                   // Wieviele Eintrge hat die Highscore?

C_MAX_ENEMY_SHOOT       = 120;                  // Wieviele Schsse knnen die Gegner maximal pro Minute absetzen?
                                                // (Achtung: EnemyTimer beachten!)
C_ENEMY_SHOOT_SPEED     = 3;                    // Wie schnell schieen die Gegner?

C_FIRE_SPEED            = 10;                   // Geschwindigkeit der Explosionen (Wie lange sichtbar)

C_PLAYERDEAD_TIME       = C_FIRE_SPEED*8+30;    // Wie lange bleibt Spieler weg (Solange wie Explosion + 30 Einheiten)
C_PLAYER_COMEBACK_TIME  = 200;                  // die Zeit in der der Spieler blinkt

C_SND_PLAYERFIRE        = 'fire.wav';           // Standard-Sound-Datei, wenn Spieler schiet
C_SND_ENEMYFIRE         = 'enfire.wav';         // Standard-Sound-Datei, wenn Gegner schiet
C_SND_HITENEMY          = 'explo.wav';          // Standard-Sound-Datei, wenn Gegner explodiert
C_SND_HITPLAYER         = 'hitplayer.wav';      // Standard-Sound-Datei, wenn Spieler explodiert


// --- Fehlermeldungen ---
C_ERR_WRONG_OPTIONS     = 'Ihre Eingaben sind fehlerhaft, bitte keine gleichen Steuerungstasten verwenden!';
C_ERR_SAVE_OPTIONS      = 'Fehler beim Speichern der Benutzereinstellungen in Datei: ';
C_ERR_LOAD_OPTIONS      = 'Fehler beim Laden der Benutzereinstellungen aus Datei: ';
C_ERR_LOAD_HIGHSCORE    = 'Fehler beim Laden der Highscore aus Datei: ';
C_ERR_SAVE_HIGHSCORE    = 'Fehler beim Speichern der Highscore in Datei: ';
C_ERR_LOAD              = ' nicht gefunden! Verwende Standard-Werte!';
C_ERR_SAVE_BITMAPS      = 'Fehler beim Speichern der Spiel-Grafiken in Datei: ';
C_ERR_IMPORT_BITMAP     = 'Fehler beim Importieren der Bitmap aus Datei: ';
C_ERR_LOAD_BITMAPS      = 'Fehler beim Laden der Spiel-Grafiken aus Datei: ';
C_ERR_LOAD_DEFAULTS     = #13+'Lege vier leere Standard Bilder als Grafiken an!';
C_ERR_LOAD_DEF_BITMAPS  = 'Fehler beim Laden der Spiel-Grafiken, das Spiel kann ohne Bilder nicht starten.';   // UMain
C_ERR_SET_FILE_ATTR     = 'Fehler beim Entfernen des Datei-Schreibschutzes von Datei: ';     // UFile

// --- Spiele-Meldungen ---
C_MSG_START_GAME        = 'Achtung das Spiel geht los!';
C_MSG_LEVEL_FINISHED    = 'Level erfolgreich!';
C_MSG_TIME_OUT          = 'Zeit vorbei! Level neu starten...';

C_MSG_SAVE_BMPS         = 'Sollen die aktuellen Bilder als Standard gespeichert werden, so dass sie fr zuknftige Spiele verwendet werden?';
C_MSG_SAVE_OPTIONS      = 'Sollen die neuen Einstellungen wirklich fr alle zuknftigen Spiele bernommen werden';

type
 TTimeRange    = 0..59;                                        // Gibt den Bereich einer Minute in Sekunden an
 TEnemyShoot   = 1..C_MAX_ENEMY_SHOOT;                         // Mglicher Bereich fr Gegner-Schsse
 TEnemyShootSet= set of TEnemyShoot;                           // Gegner-Schuss-Menge mit Werten aus dem Bereich

 TGameStatus   = ( St_Playing, St_TimeOver, St_FinishedLevel, St_PlayerDead, St_PlayerComeBack, St_Pause, St_NoGame);

 TPlayTime     = record                                        // Record das die Rundenzeit speichern kann
                    Hours        : TTimeRange;                 // wieviele Stunden
                    Minutes      : TTimeRange;                 // wieviele Minuten
                    Seconds      : TTimeRange;                 // wieviele Sekunden
                 end;

 TBmpLstPtr    = ^TBmpLst;                                     // Zeiger auf eine Bildliste (fr TExtImgLst)
 TBmpLst       = record                                        // Ein Element der Bilderliste mit folg. Inhalt:
                    Size         : Byte;                       // enthlt die Gre (in %) des Bildes auf dem Spielfeld
                    Bmp          : TBitmap;                    // das Bitmap/Grafik
                    Prev         : TBmplstPtr;                 // Zeiger auf Vorgnger in der Bilderliste
                    Next         : TBmpLstPtr;                 // Zeiger auf Nachfolger in der Bilderliste
                 end;


 TRealPoint    = record                                        // Pendant zu TPoint, nur mit Kommazahlen
                    X,Y          : Real;                       // Position x und y
                 end;


 TMoveRec      = record                                        // speichert Bewegungs- und Schussinformationen der Gegner
                    Pos          : TRealPoint;                 // aktuelle Position auf dem Spielfeld
                    NewPos       : TRealPoint;                 // nchster Punkt, zu dem hin bewegt wird
                    Shoot        : TEnemyShootSet;             // enthlt die Schussinfos
                 end;


 TFighterRec   = record                                        // enthlt Infos fr ein Spiel-Objekt
                    x,y          : Integer;                    // Position des Objekts
                    Speed        : Integer;                    // Geschwindigkeit des Objekts
                    Width,Height : Integer;                    // Breite und Hhe in Pixel des Objekts
                    Color        : TColor;                     // Farbe des Objekts
                    Lives        : Integer;                    // Anzahl Leben / Gltigkeit des Objekts
                    Size         : Integer;                    // Gre, Level, Counter des Objekts
                    Str          : string;                     // Text-Infos fr Text-Objekt
                    Move         : TMoveRec;                   // Bewegungs- Schuss-Infos fr Gegner-Objekt
                 end;

 TFighterPtr   = ^TFighter;                                    // Zeiger auf eine Fighter-Objekt-Liste

 TFighter      = record                                        // Ein element der Liste
                    Data         : TFighterRec;                // Inhalt des Elements (Pos, Speed,Color...)
                    Prev         : TFighterPtr;                // Zeiger auf Vorgnger in der Liste
                    Next         : TFighterPtr;                // Zeiger auf Nachfolger in der Liste
                 end;


 TPlayername   = String[C_MAX_PLAYERNAME_LEN];                 // String fr Spielername in Highscore
 TScoreElement = record                                        // Ein Eintrag aus der Highscore
                    PlayerName   : TPlayerName;                // mit Spieler-Namen
                    PlayerPoints : Cardinal;                   // und erreichte Punktzahl
                 end;

 THighscore    = array[1..C_MAX_HIGHSCORE_ENTRIES] of TScoreElement;


 TGame         = record                                        // speichert wichtige Information fr ein Spiel
                    // Allgemein
                    FieldSize    : Integer;                    // Spielfeldgre
                    Status       : TGameStatus;                // aktueller Spiel-Status (Pause, Level geschafft...)
                    LevelTime    : Cardinal;                   // Rundenzeit des Levels
                    Lives        : Integer;                    // Anzahl Leben des Spielers
                    NiceLook     : Boolean;                    // sollen hochauflsende Explsoionen benutzt werden?

                    // Sterne
                    StCount      : Word;                       // Anzahl der Sterne in Hintergrund
                    StMaxSpeed   : Byte;                       // Maximale Geschwindigkeit der Sterne

                    // Tasten
                    CtrLeft      : Word;                       // Steuertaste Links
                    CtrRight     : Word;                       // Steuertaste Rechts
                    CtrFire      : Word;                       // Steuertaste Schieem
                    CtrPause     : Word;                       // Steuertaste Pause

                    // Gegner
                    EnPoints     : Cardinal;                   // Punktzahl fr ein getroffenen Gegner in Level 1
                    EnCount      : Word;                       // Anzahl der Gegner im ersten Level
                    EnIncCount   : Word;                       // Wieviele Gegner pro Level mehr?
                    EnSpeed      : Byte;                       // Geschwindikeit der Gegner in Level 1
                    EnIncSpeed   : Byte;                       // Erhhung der Geschwindigkeit pro Level
                    EnFire       : Byte;                       // Schussfrequenz der Gegner in Level 1
                    EnIncFire    : Byte;                       // Erhhung der Schussfrequenz pro Level
                 end;


// var
// PtrDebug : Integer;                                         // Variable zum Debuggen der Zeiger (Fighter-Listen)
// LstDebug : Integer;                                         // Variable zum Debuggen der Zeiger (Bilderlisten)

implementation

end.

